use std::io::prelude::*;
use std::net::TcpStream;
use std::net::TcpListener;
use std::fs;

fn main() {
    let listener = TcpListener::bind("127.0.0.1:7878").unwrap();

    for stream in listener.incoming() {
        let stream = stream.unwrap();

        handle_connection(stream);
    }
}

fn handle_connection(mut stream: TcpStream) {
    let mut buffer = [0; 512];

    stream.read(&mut buffer).unwrap();

    let get = b"GET / HTTP/1.1\r\n";

    println!("Request: {}", String::from_utf8_lossy(&buffer[..]));

    let mut respond = |headers, response| {
        stream.write(headers).unwrap();
        stream.write(response).unwrap();
        stream.flush().unwrap();
    };

    if buffer.starts_with(get) {

        let bytes = fs::read_to_string("public/index.html").unwrap();
        respond("HTTP/1.1 200 OK\r\n\r\n".as_bytes(), bytes.as_bytes())

    } else {

        respond("HTTP/1.1 404 NOT FOUND\r\n\r\n".as_bytes(), "Couldn't find {}".as_bytes())

    }
}
